#if !defined(AFX_MANUALEDITDLG_H__A4E9233D_2CFE_415F_8624_F1D6FEB6BC7A__INCLUDED_)
#define AFX_MANUALEDITDLG_H__A4E9233D_2CFE_415F_8624_F1D6FEB6BC7A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ManualEditDlg.h : wb_[ t@C
//
#include "DialogEx.h"
#include "ManualEditDocument.h"
#include "LixxxtrlEx1.h"

/////////////////////////////////////////////////////////////////////////////
// CManualEditDlg _CAO

class CManualEditDlg : public CDialogEx
{
	// vfƃXgf[^
	struct SYosoSagyoList {
		int nIndex;					// CfbNXԍ
		int nEditFlag;				// ҏWtO
		BOOL bErrorFlag;			// G[tO
		int nYosoSagyoId;			// vfID
		CString sYosoSagyoName;		// Ɠe
		CString sYosoSagyoNo;		// vfNO
// --Add 2007/02/26 aizawa sD-187
		int nSagyoNo;				// No
// --Add
		CString sEnzanShiki;		// Z
		double fS1;					// S1
		double fS2;					// S2
		double fM;					// M
		BOOL bM;					// M̓tO
		double fN;					// N
		BOOL bN;					// N̓tO
		int nHassexxxndo;			// px
		BOOL bHassexxxndo;			// px̓tO
		int nKurikaeshiKaisu;		// JԂ
		BOOL bKurikaeshiKaisu;		// JԂ񐔓̓tO
		CString sKoteibuHendobu;	// Œ^ϓ
		CString sSagyoFlag;			// ƃtO
		int nKijunKotei;			// ^H
		BOOL bKijunKotei;			// ^H̓tO
	};
	typedef CArrayEx <SYosoSagyoList, SYosoSagyoList&> CYosoSagyoListArray;
	
	// vfƌQXgf[^
	struct SYosoSagyogunList {
		int nIndex;					// CfbNXԍ
		int nEditFlag;				// ҏWtO
		BOOL bErrorFlag;			// G[tO
		int nYosoSagyogunId;		// vfƌQID
		CString sYosoSagyogunName;
		BOOL bKyotsuKotei;
		CYosoSagyoListArray aYosoSagyoList;
	};
	typedef CArrayEx <SYosoSagyogunList, SYosoSagyogunList&> CYosoSagyogunListArray;

	// HXgf[^
	struct SKoteiList {
		int nIndex;					// CfbNXԍ
		int nEditFlag;				// ҏWtO
		BOOL bErrorFlag;			// G[tO
		CString sSubline;			// TuC
		CString sKoteiKigo;			// HL
		CString sKoteiNo;			// Hԍ
		CString sKoteiName;			// H
		CString sJidoShudo;			// ^蓮
		BOOL bKyotsuKotei;
		CYosoSagyogunListArray aYosoSagyogunList;
	};
	typedef CArrayEx2 <SKoteiList, SKoteiList&> CKoteiListArray;

	// Ǝ҃Xgf[^
	struct SSagyoshaList {
		int nSublineId;
		int nSagyoshaId;
		CString sSagyoshaName;
		CString sKoteiKigo;
		CKoteiListArray aKoteiList;
	};
	typedef CArrayEx <SSagyoshaList, SSagyoshaList&> CSagyoshaListArray;

// RXgNV
public:
	CManualEditDlg(CWnd* pParent = NULL);   // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CManualEditDlg)
	enum { IDD = IDD_MANUAL_EDIT };
	CButton	m_cButtonYosoSagyoTsuika;
	CButton	m_cButtonYosoSagyoSakujo;
	CMyEdit	m_cEditKishuName;
	CLixxxtrlEx	m_cListKotei;
	CLixxxtrlEx	m_cListYosoSagyogun;
	CLixxxtrlEx	m_cListYosoSagyo;
	CComboBox	m_cComboSagyosha;
	//}}AFX_DATA

	int m_nSagyoshaId;				// ƎID
	int m_nKishuId;					// @ID
	CManualEditDocument *m_pDoc;	// hLgNXւ̃|C^


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CManualEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CManualEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeComboSagyosha();
	afx_msg void OnItemchangedListKotei(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedListYosoSagyogun(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnButtonYosoSagyoSakujo();
	afx_msg void OnButtonYosoSagyogunSakujo();
	afx_msg void OnButtonKoteiSakujo();
	afx_msg void OnButtonYosoSagyoTsuika();
	afx_msg void OnButtonYosoSagyogunTsuika();
	afx_msg void OnButtonKoteiTsuika();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnButtonPreview();
	//}}AFX_MSG
	afx_msg LRESULT OnChangeCombo(WPARAM wp, LPARAM lp);
	afx_msg LRESULT CreateComboList(WPARAM wp, LPARAM lp);
	afx_msg LRESULT OnChangeEdit(WPARAM wp, LPARAM lp);
	DECLARE_MESSAGE_MAP()

	CSagyoshaListArray m_aSagyoshaList;	// Ǝ҃Xgf[^
	CSagyoshaListArray m_aSagyoshaList2;	// Ǝ҃Xgf[^

	int m_nSublineId;

	void SetSagyoshaList();
	void SetKoteiList(int nSelectIndex = -1);
	void SetYosoSagyogunList(int nSelectIndex = -1);
	void SetYosoSagyoList(int nSelectIndex = -1);
	void EditKotei(int nRow, int nCol);
	void EditYosoSagyogun(int nRow, int nCol);
	void EditYosoSagyo(int nRow, int nCol);
	void SetYosoSagyoTemplate(SYosoSagyoList &cYosoSagyoList);
	CString GetKijunKoteiString(int nKijunKotei);
	void MakeSagyoshaList();
	void MakeKoteiList(int nSublineId, int nSagyoshId, CKoteiListArray &aKoteiList);
	void MakeYosoSagyogunList(int nYosoSagyogunId, SYosoSagyogun &cYosoSagyogun, CYosoSagyogunListArray &aYosoSagyogunList);
	void MakeYosoSagyoList(SYosoSagyogun &cYosoSagyogun, CYosoSagyoListArray &aYosoSagyoList);
	int GetSelectSagyosha();
	int GetSelectKotei();
	int GetSelectYosoSagyogun();
	int GetSelectYosoSagyo();
	void EnableYosoSagyoTsuikaSakujo();
	void DispList(int nSagyoshaIndex, int nKoteiIndex = -1, int nYosoSagyogunIndex = -1);
	BOOL CheckData();
	void ClearErrorFlag();
	void SetChangeFlag();
	BOOL CheckMinyuryoku();
	BOOL CheckInputData();
	BOOL CheckInputDataSub(CDataCheck &cDataCheck, LPCTSTR pData);
	BOOL CheckInputDataSub(CDataCheck &cDataCheck, double fData);
	BOOL CheckSameKotei();
	BOOL CheckSameYosoSagyogun();
	BOOL CheckYosoSagyogun();
	BOOL CheckYosoSagyo();
	BOOL CheckKyotsuKotei();
	void ChangeData();
	void DeleteData();
	void InsertData();
	void SetYosoSagyoData(SYosoSagyo &cYosoSagyo, SYosoSagyoList &cYosoSagyoList);
	double CalcEnzangoSagyoJikan(SYosoSagyoList &cYosoSagyoList);
	double CalcDaiatariSagyoJikan(SYosoSagyoList &cYosoSagyoList, double fEnzangoSagyoJikan);
	CString ConvertHankaku(LPCTSTR pText);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_MANUALEDITDLG_H__A4E9233D_2CFE_415F_8624_F1D6FEB6BC7A__INCLUDED_)
